SimpleView subclass:#ExtendedComboBox
	instanceVariableNames:'readOnly pressButton editField popupView popupDescriptor
		widgetModel minPopupHeight maxPopupHeight openNormal
		popupViewCorner'
	classVariableNames:''
	poolDictionaries:''
	category:'Views-Interactors'
!

SimpleView subclass:#Popup
	instanceVariableNames:'hasFocus pointerInScrollbar pointerScrollbarView'
	classVariableNames:''
	poolDictionaries:''
	privateIn:ExtendedComboBox
!


!ExtendedComboBox class methodsFor:'testing'!

testing2SelectionInList
"
self testing2SelectionInList
"
    | top comboBox theSelView list |

    top := StandardSystemView extent:200@35.
    comboBox := ExtendedComboBox origin:5 @ 5 corner:1.0 @ 30 in:top.

    comboBox popupDescriptor:[
        theSelView := SelectionInListView new.
        list := #('foo' 'bar' 'baz' 'hjh' 'kk' 'ljhllllllllllAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAallllllllllllllllllllllllllllkj' 'gjhj').
        theSelView list:list.
        theSelView action:[:i| comboBox value:(list at:i) ].
        theSelView.
    ].
    comboBox popupHeight:45.
    top open

    "Modified: / 27.11.1998 / 18:18:41 / you"
    "Created: / 5.12.1998 / 15:43:07 / ps"
    "Modified: / 5.12.1998 / 17:01:43 / ps"
!

testing4SelectionInList

"
self testing4SelectionInList
"

    | top comboBox theSelView list |

    top := StandardSystemView extent:200@35.
    comboBox := ExtendedComboBox origin:5 @ 5 corner:1.0 @ 30 in:top.
    theSelView := SelectionInListView new.
    list := #('foo' 'bar' 'baz' 'hjh' 'kk' 'ljhllllllllllAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAallllllllllllllllllllllllllllkj' 'gjhj').
    theSelView list:list.
    theSelView action:[:i| comboBox value:(list at:i) ].
    theSelView doubleClickAction:[:i| 
        "comboBox closePopup."
        theSelView list add:'1'].

    comboBox popupDescriptor:[theSelView].

    top open

    "Modified: / 27.11.1998 / 18:18:41 / you"
    "Modified: / 5.12.1998 / 17:15:54 / ps"
!

testingSelectionInList

"
self testingSelectionInList
"

    | top comboBox theSelView theSelList |

    top := StandardSystemView extent:200@35.
    comboBox := ExtendedComboBox origin:5 @ 5 corner:1.0 @ 30 in:top.
    comboBox popupDescriptor:[
        theSelView := SelectionInListView new.
        theSelList := SelectionInList new.
        theSelList listHolder:#('foo' 'bar' 'baz')asValue.
        theSelView model:theSelList.
        comboBox model:(theSelList selectionHolder).
        theSelView.
    ].

    top open

    "Modified: / 27.11.1998 / 18:18:41 / you"
    "Modified: / 5.12.1998 / 17:15:54 / ps"
!

testingSelectionInTreeView
"
self testingSelectionInTreeView
"
    |top comboBox scrView theTreeView theSelList|

    top := StandardSystemView extent:325@70.
    comboBox := ExtendedComboBox origin:25 @ 25 corner:300 @ 45 in:top.

    comboBox popupDescriptor:[
        | oldModel |
        theTreeView := Smalltalk::FileSelectionTree new.
        (oldModel := comboBox model) notNil
            ifTrue:[
                theTreeView selectionHolder:oldModel]
            ifFalse:[
                theTreeView selectionHolder:(ValueHolder new)].
        theTreeView directory:(Filename homeDirectory).
        theTreeView showDirectoryIndicator:true.
        theTreeView doubleClickAction:[:index|
            comboBox closePopup.
        ].
        scrView := ScrollableView forView:theTreeView
                hasHorizontalScrollBar:true
                hasVerticalScrollBar:true
                miniScrollerH:true
                miniScrollerV:false
                origin:nil
                corner:nil 
                in:nil.
        comboBox model:(theTreeView selectionHolder).
        scrView.
    ].
    top open.

    "Created: / 27.11.1998 / 18:29:51 / you"
    "Modified: / 27.11.1998 / 18:35:08 / you"
    "Modified: / 5.12.1998 / 17:16:07 / ps"
!

testingSelectionInTreeView1
"test for the extended combobox.
open a combobox with a selection in tree view on the users home directory.
The selected item is shown in the label field. The selection is not set in
the tree view on reopening.

self testingSelectionInTreeView1
"
    |top comboBox scrView theTreeView theSelList|

    top := StandardSystemView extent:325@70.
    comboBox := ExtendedComboBox origin:25 @ 25 corner:300 @ 45 in:top.
    comboBox minPopupHeight:100.
    comboBox maxPopupHeight:200.
    comboBox popupDescriptor:[
        | oldModel |
        theTreeView := Smalltalk::FileSelectionTree new.
        (oldModel := comboBox model) notNil
            ifTrue:[
                theTreeView selectionHolder:oldModel]
            ifFalse:[
                theTreeView selectionHolder:(ValueHolder new)].
        theTreeView directory:(Filename homeDirectory).
        theTreeView showDirectoryIndicator:true.
        theTreeView doubleClickAction:[:index|
            comboBox closePopup.
        ].
        scrView := ScrollableView forView:theTreeView
                hasHorizontalScrollBar:true
                hasVerticalScrollBar:true
                miniScrollerH:true
                miniScrollerV:false
                origin:nil
                corner:nil 
                in:nil.
        comboBox model:(theTreeView selectionHolder).
        scrView.
    ].
    top open.

    "Modified: / 5.12.1998 / 17:16:07 / ps"
!

testingSelectionInTreeView2
"test for the extended combobox.
open a combobox with a selection in tree view on the users home directory.
The selected item is shown in the label field. The selection in tree view tries
to restore the selcted item if opened.

self testingSelectionInTreeView2
"
    |top comboBox scrView theTreeView theSelList|

    top := StandardSystemView extent:325@70.
    comboBox := ExtendedComboBox origin:25 @ 25 corner:300 @ 45 in:top.
    comboBox minPopupHeight:100.
    comboBox maxPopupHeight:200.
    comboBox popupDescriptor:[
        | oldModel |
        theTreeView := Smalltalk::FileSelectionTree new.
        theTreeView selectionHolder:(ValueHolder new).
        theTreeView directory:(Filename homeDirectory).
        theTreeView showDirectoryIndicator:true.
        theTreeView doubleClickAction:[:index|
            comboBox closePopup.
        ].
        scrView := ScrollableView forView:theTreeView
                hasHorizontalScrollBar:true
                hasVerticalScrollBar:true
                miniScrollerH:true
                miniScrollerV:false
                origin:nil
                corner:nil 
                in:nil.
        (oldModel := comboBox model) notNil
            ifTrue:[theTreeView selectionHolder value:(oldModel value)].
        comboBox model:(theTreeView selectionHolder).
        scrView.
    ].
    top open.

    "Modified: / 5.12.1998 / 17:16:07 / ps"
! !

!ExtendedComboBox methodsFor:'accessing'!

popupDescriptor
"returns the descriptor for the extended combobox.

return <aPopupDescriptor>"

    ^ popupDescriptor

    "Modified: / 27.11.1998 / 17:01:24 / you"
    "Created: / 4.12.1998 / 12:57:36 / ps"
!

popupDescriptor:aPopupDescriptor
"sets the descriptor for the extended combobox. The desciptor is evaluated with
the method value; therefore its usually a none arg block. The popup descriptor is
obligated to return a view.

return <self>
"

    popupDescriptor := aPopupDescriptor

    "Modified: / 27.11.1998 / 17:01:24 / you"
    "Created: / 4.12.1998 / 12:57:15 / ps"
    "Modified: / 5.12.1998 / 13:42:38 / ps"
!

readOnly
"return the value of the instance variable 'readOnly'
indicates the type of the edit field:
readOnly = true: type is kind of label
readOnly = false: type is kind of edit field

return <boolean>"

    ^ readOnly

    "Created: / 5.12.1998 / 12:41:43 / ps"
!

readOnly:aBoolean
"set the value of the instance variable 'readOnly'
indicates the type of the edit field:
readOnly = true: type is kind of label
readOnly = false: type is kind of edit field

return <self>"


    readOnly := aBoolean

    "Created: / 5.12.1998 / 12:41:43 / ps"
! !

!ExtendedComboBox methodsFor:'accessing-dimension'!

maxPopupHeight
"return the value of the instance variable 'maxPopupHeight'

return <integer>"

    ^ maxPopupHeight
!

maxPopupHeight:aHeight
"set the value of the instance variable 'maxPopupHeight'

return <self>"

    maxPopupHeight := aHeight.
!

minPopupHeight
"return the value of the instance variable 'minPopupHeight'

return <integer>"

    ^ minPopupHeight
!

minPopupHeight:aHeight
"set the value of the instance variable 'minPopupHeight'

return <self>"

    minPopupHeight := aHeight.
! !

!ExtendedComboBox methodsFor:'accessing-mvc'!

model
"return the model of the edit field

return <aValueHolder>"

    ^ editField model

    "Created: / 5.12.1998 / 15:08:21 / ps"
    "Modified: / 5.12.1998 / 15:57:50 / ps"
!

model:aModel
"sets the model of the edit field for automatik update its content. If using a model the
value holder or ascpect adaptor is responsible to set a valid value to the edit field.
This depends on the type of the edit field: label or edit field. To set the content of the
edit field without a model please use the methode value:aContent.

return <self>"

    "perhaphs ..."
    "super model:aModel."
    editField model:aModel

    "Created: / 27.11.1998 / 16:58:41 / you"
    "Modified: / 5.12.1998 / 15:57:54 / ps"
!

value
"return the value of the edit field. If the edit field is a label the value can be a string
or a labelAndString etc.; if it's kind of a edit field only a string can be returned.
If the edit field isn't initialized return nil.

return <nil | string | labelAndString >"

    editField notNil ifTrue:[
        ^ readOnly ifTrue: [editField label]
                   ifFalse:[editField contents]
    ].
    ^ nil

    "Created: / 5.12.1998 / 16:01:17 / ps"
!

value:aValue
"set the value of the edit field. If the edit field is a label the value can be set
without conversion (readonly indicates the type of the edit field); if it's kind of a
edit field only a string can be set as the content

return <self>"

    editField notNil ifTrue:[
        readOnly ifTrue:[
           ^ editField label:aValue
        ].
        aValue isString ifTrue:[editField contents:aValue]
                       ifFalse:[editField contents:aValue printString].
    ].

    "Created: / 5.12.1998 / 16:03:41 / ps"
! !

!ExtendedComboBox methodsFor:'accessing-private'!

openNormal
"return the value of the instance variable 'openNormal'
if it is true the popup view will be opend under the edit field
if it is false it will be opended over the edit field.

return <boolean>"

    ^ openNormal
!

openNormal:something
"set the value of the instance variable 'openNormal'. Yet only for private use because
the positing routine doesn't support userdefined opening strategies

return <self>"

    openNormal := something.
! !

!ExtendedComboBox methodsFor:'action'!

XbuttonPressed

    |point widget maxY minSpace action widgetExt scrollerX scrollerY scr|

    minSpace := false.
    point := device translatePoint:(0@height)
                              from:(self id)
                                to:(device rootWindowId).
    popupView notNil ifTrue:[
        ^ self closePopup.
    ].
    widget := self popupDescriptor value.

    "calculate max extent of the popup view"
    maxY := device usableHeight - point y - 4.
    "check if enough space is avaiable beneath the combo box (min space is set to 50 pixels)"
    "if ont enough space is available, the popup will be opened over the combo box"
    maxY < 50 ifTrue:[
        minSpace := true.
        maxY := point y - height.
    ].
    fixedHeight notNil ifTrue:[
        fixedHeight < maxY ifTrue:[
            maxY := fixedHeight
        ].
    ].
    "is the preferredExtent of the widget small than the max extent"
    "if true use the preferredExtent if false use the max extent and"
    "add scrollbars if the widget has not already scroller"
    widgetExt := (widget widthOfContents @ widget heightOfContents).
    (widget isKindOf:ScrollableView) ifFalse:[
        self halt.
        widgetExt x > width ifTrue:[
            scrollerX := true.
        ]ifFalse:[
            scrollerX := false.
        ].
        widgetExt y > maxY ifTrue:[
            scrollerY := true.
        ]ifFalse:[
            scrollerY := false.
        ].
        (scrollerY or:[scrollerX]) ifTrue:[
            scr := ScrollableView forView:widget hasHorizontalScrollBar:scrollerX
                                            hasVerticalScrollBar:scrollerY
                                                   miniScrollerH:true
                                                   miniScrollerV:false 
                                                          origin:nil
                                                          corner:nil
                                                              in:nil.
            scr add:widget.
            popupView := Popup extent:(width@maxY) popupView:scr.
        ]ifFalse:[
            popupView := Popup extent:(width@(widgetExt y)) popupView:widget.
        ].
    ]ifTrue:[
        popupView := Popup extent:(width@maxY) popupView:widget.
    ].

"/    popupView add:(self popupDescriptor value).
"/    popupView extent:(width @ maxY).
    popupView level:1.
    minSpace ifTrue:[
        point y:(point y - popupView height - height).
    ].
    (widget respondsTo:#doubleClickAction:) ifTrue:[
        action := widget perform:#doubleClickAction.
        action isNil ifTrue:[
            widget perform:#doubleClickAction: with:[:aValue|
                self closePopup
            ].
        ]
    ].
    popupView openModalAt:point.
    self closePopup.
    pressButton turnOff.

    "Modified: / 5.12.1998 / 16:47:02 / ps"
    "Created: / 5.12.1998 / 16:52:17 / ps"
!

buttonPressed
"the arrow button of the combobox is pressed, open the popup view.
Get the view to pop up via the descriptor an check if enough space is
available under the edit field to open the popup view.

return <self>"

    | point widget |

    point := device translatePoint:(0@height)
                              from:(self id)
                                to:(device rootWindowId).
    "popup view is open, close it"
    popupView notNil ifTrue:[^self closePopup].

    "get the widget view for the descriptor"
    widget := self popupDescriptor value.
    "check if the preferredExtent of the widget is smaller than the max extent"
    "if true use the preferredExtent if false use the max extent and"
    "add scrollbars if the widget has not already scroller"
    popupView := self checkWidgetForScrollbars:widget with:point.

    "do we have to open the popup view over the combobox"
    "if true recalculate the open point"
    self openNormal ifFalse:[point y:(point y - popupView height - height)].
    "does the widget has a double click action"
    "if true check if it is set and if not set the widget a default action"
    "if you want to disable the default doubleclick action (close the popup view), "
    "give the widget an empty action block"
    self checkForDoubleClickAction:widget.

    popupView openModalAt:point.
    self closePopup.
    "pop up view is closed -> turn arrow button off"
    pressButton turnOff.

    "Modified: / 5.12.1998 / 17:13:52 / ps"
! !

!ExtendedComboBox methodsFor:'calculation'!

calcMaxExtentForPopupView:aOpenPoint
"check if the space beneath the combo box is greater then the min height
(if the min height is not defined it will be set to 50 pixels)
if not enough space is available, the popup will be opened over the combo box
with its max height

return <point>"

    | maxHeight |

    "set default opening strategie"
    self openNormal:true.
    "calculate max extent of the popup view"
    maxHeight := device usableHeight - aOpenPoint y - 4.
    "check if the space beneath the combo box is greater then the min height"
    "(if the min height is not defined it will be set to 50 pixels)"
    "if not enough space is available, the popup will be opened over the combo box"
    "with its max height (see below)"
    maxHeight < (minPopupHeight ? 50)
        ifTrue:[                 
            self openNormal:false.
            maxHeight := aOpenPoint y - height].
    "is a special height given and is it smaller then the maxHeight height"
    "use it as max height"
    maxPopupHeight notNil
        ifTrue:[
            maxPopupHeight < maxHeight
                ifTrue:[maxHeight := maxPopupHeight]].

    ^(width@maxHeight)
!

checkForDoubleClickAction:aWidget
"does the widget aWidget has a double click action
if true check if it is set and if not give the widget a default action.
To disable the default action, set the widget aWidget a empty action block in the descriptor.

return <self>"

    | action |

    (aWidget respondsTo:#doubleClickAction:)
        ifTrue:[
            action := aWidget perform:#doubleClickAction.
            action isNil
                ifTrue:[
                    aWidget perform:#doubleClickAction: with:[:aValue|self closePopup]]]

!

checkWidgetForScrollbars:aWidget with:aOpenPoint
"check if the contents extent of the widget aWidget is smaller than 
the max extent for the popup view:
if true use the contents extent for the popup view
if false use the max extent and add scrollbars if the widget has not already scroller

return <view>"

    | popupExtent widgetExt scr popupView |

    "calculate the preferred extent for the popup view"
    popupExtent := self calcMaxExtentForPopupView:aOpenPoint.
    "preferred extent of the widget"
    widgetExt := (aWidget widthOfContents @ aWidget heightOfContents).
    "add space for level etc."
    widgetExt := widgetExt + 8.
    "if aWidget has no scrollbars check if vertical or horizontal scrollbars are necessary"
    (aWidget isKindOf:ScrollableView)
        ifFalse:[
            "if adding a horizontal scroller add space to the widget height"
            widgetExt x > width
                ifTrue:[widgetExt y:(widgetExt y + 10)].
            (widgetExt x > width or:[widgetExt y > popupExtent y])
                ifTrue:[
                    "add scrollbars; turn autoHide on"
                    scr := ScrollableView forView:aWidget hasHorizontalScrollBar:true
                                                            hasVerticalScrollBar:true
                                                                   miniScrollerH:true
                                                                   miniScrollerV:false 
                                                                          origin:nil
                                                                          corner:nil
                                                                              in:nil.
                    scr level:1.
                    scr borderWidth:1.
                    scr add:aWidget.
                    scr autoHideScrollBars:true.
                    popupView := Popup extent:(width@(widgetExt y min:popupExtent y)) popupView:scr]
                ifFalse:[
                    "no scrollbars"
                    popupView := Popup extent:(width@(widgetExt y)) popupView:aWidget].
        ]ifTrue:[
            "no scrollbars"
            popupView := Popup extent:(width@popupExtent y) popupView:aWidget].
    popupView level:2.
    ^ popupView
! !

!ExtendedComboBox methodsFor:'initialization'!

closePopup
"shuts down the popup view, this ungrabbes the event handling !!!!!!

return <self>"

    popupView notNil ifTrue:[
        popupView destroy.
        popupView := nil.
    ].

    "Created: / 4.12.1998 / 12:54:09 / ps"
!

destroy
"very important: close popup to ungrab event handling

return <self>"

    self closePopup.
    super destroy.

    "Created: / 4.12.1998 / 12:53:23 / ps"
    "Modified: / 5.12.1998 / 14:26:59 / ps"
!

initialize
"set default things up and get a arrow button for the combobox

return <self>"

    super initialize.
    self label:'ExtendedComboBox-Test'.
    readOnly    := true.
    pressButton := ArrowButton  origin:1.0@0.0 corner:1.0@1.0 in:self.
    pressButton direction:#down.
    pressButton pressAction:[self buttonPressed].
    pressButton leftInset:((5 + pressButton preferredExtent x) negated).

    self openNormal:true.

    "Modified: / 27.11.1998 / 18:28:19 / you"
    "Modified: / 5.12.1998 / 13:53:00 / ps"
!

realize
"when we are realized we have to initialize the edit field:
if readonly is true we use a Label (this allows to show icons)
if we like to edit we have to use a edit field (only strings here)

return <self>"

    readOnly
        ifFalse:[
            editField := EditField extent:1.0 @ 1.0 in:self]
        ifTrue:[
            editField := Label extent:1.0 @ 1.0 in:self.
            editField adjust:#left.
            editField labelMessage:#value.
            editField level:-1].
    editField rightInset:(pressButton leftInset negated).

    super realize.

    "Created: / 27.11.1998 / 17:02:53 / you"
    "Modified: / 27.11.1998 / 18:18:52 / you"
    "Modified: / 5.12.1998 / 15:58:19 / ps"
! !

!ExtendedComboBox::Popup class methodsFor:'instance creation'!

extent:aPoint popupView:aView

    ^ super new extent:aPoint popupView:aView

    "Modified: / 5.12.1998 / 14:31:53 / ps"
    "Created: / 5.12.1998 / 14:47:53 / ps"
! !

!ExtendedComboBox::Popup methodsFor:'event handling'!

buttonMotion:button x:x y:y
    |p view|

    pointerInScrollbar ifTrue:[
        "the pointer was pressed in the scrollbar and yet not released"
        "therefore send all motion events to the scrollbar"
        p := device translatePoint:(x@y) from:(self id) to:(pointerScrollbarView id).
        pointerScrollbarView buttonMotion:button x:p x y:p y
    ]ifFalse:[
        (((view := self detectViewAtX:x y:y) notNil) and:[view ~~ self])ifTrue:[
            p := device translatePoint:(x@y) from:(self id) to:(view id).
            (view controller notNil 
            and:[view controller ~~ view]) ifTrue:[
                view controller buttonMotion:button x:p x y:p y 
            ] ifFalse:[
                view buttonMotion:button x:p x y:p y
            ]
        ].
    ].

    "Modified: / 27.11.1998 / 15:16:09 / ps"
    "Created: / 5.12.1998 / 14:19:55 / ps"
!

buttonMultiPress:button x:x y:y
    |p view|

    (view := self detectViewAtX:x y:y) isNil ifTrue:[
       self destroy.
    ] ifFalse:[
        p := device translatePoint:(x@y) from:(self id) to:(view id).
        (view controller notNil 
        and:[view controller ~~ view]) ifTrue:[
            view controller buttonMultiPress:button x:p x y:p y 
        ] ifFalse:[
            view buttonMultiPress:button x:p x y:p y
        ]
    ].

    "Created: / 5.12.1998 / 14:20:02 / ps"
    "Modified: / 5.12.1998 / 14:27:16 / ps"
!

buttonPress:button x:x y:y
    |p view theViewClass|

    (view := self detectViewAtX:x y:y) isNil ifTrue:[
        self destroy.
    ] ifFalse:[
        "check if the pointer is pressed in a scrollbar"
        theViewClass := view class.
        (theViewClass == (Smalltalk at:#Scroller) 
                or:[theViewClass == (Smalltalk at:#HorizontalMiniScroller)
                or:[theViewClass == (Smalltalk at:#VerticalMiniScroller)]]) ifTrue:[
            "set flag for pointer pressed in scrollbar"
            "this enables monitoring of scrolling"
            pointerInScrollbar := true.
            pointerScrollbarView := view.
        ].
        p := device translatePoint:(x@y) from:(self id) to:(view id).
        (view controller notNil 
        and:[view controller ~~ view]) ifTrue:[
            view controller buttonPress:button x:p x y:p y 
        ] ifFalse:[
            view buttonPress:button x:p x y:p y
        ]
    ].

    "Created: / 5.12.1998 / 14:20:07 / ps"
    "Modified: / 5.12.1998 / 14:27:57 / ps"
!

buttonRelease:button x:x y:y
    |p view t|

    pointerInScrollbar ifTrue:[
        "if the pointer was pressed in the scrollbar, set the pressed flag to false"
        "and indicate the scrollbar the release of the button"
        pointerInScrollbar := false.
        pointerScrollbarView buttonRelease:button x:x y:y.
        pointerScrollbarView := nil.
    ].
    (view := self detectViewAtX:x y:y) isNil ifTrue:[
"/        self halt.
"/        t := master buttonRelease:button x:x y:y.
"/        (t == master) ifTrue:[
"/            ^self
"/        ]ifFalse:[
"/            self acceptOn:nil
"/        ].
    ] ifFalse:[
        p := device translatePoint:(x@y) from:(self id) to:(view id).
        (view controller notNil 
        and:[view controller ~~ view]) ifTrue:[
            view controller buttonRelease:button x:p x y:p y
        ] ifFalse:[
            view buttonRelease:button x:p x y:p y
        ]
    ].

    "Created: / 5.12.1998 / 14:20:14 / ps"
    "Modified: / 5.12.1998 / 15:03:04 / ps"
!

keyPress:key x:x y:y
    |view|

    (view := self detectViewAtX:x y:y) notNil ifTrue:[
        view ~~ self ifFalse:[
            view keyPress:key x:x y:y
        ]
    ].

    "Modified: / 2.11.1998 / 15:00:32 / ps"
    "Created: / 5.12.1998 / 14:20:20 / ps"
! !

!ExtendedComboBox::Popup methodsFor:'grabbing'!

grabMouseAndKeyboard
"get exclusive access to pointer and keyboard.
Only used for popUp menus.

return <self>"

    |sensor|

    realized ifTrue:[
        hasFocus := true.
        sensor := self sensor.
        device activePointerGrab ~~ self ifTrue:[
            sensor notNil ifTrue:[
                sensor flushMotionEventsFor:nil.
            ].

            (device grabPointerInView:self) ifFalse:[
                Delay waitForSeconds:0.1.
                (device grabPointerInView:self) ifFalse:[
                    "give up"
                    'MenuPanel [warning]: could not grab pointer' errorPrintCR.
                    self unmap
                ]
            ]
        ].

        device activeKeyboardGrab ~~ self ifTrue:[
            sensor notNil ifTrue:[
                device sync.
                sensor flushKeyboardFor:nil
            ].
            device grabKeyboardInView:self.
            self getKeyboardFocus.
        ]
    ]

    "Created: / 5.12.1998 / 14:20:41 / ps"
    "Modified: / 5.12.1998 / 14:25:11 / ps"
!

ungrabMouseAndKeyboard
"ungrab resources (mouse and keyboard)

return <self>"   

    |sensor|

    hasFocus ifTrue:[
        hasFocus := false.
        device ungrabPointer.

        (sensor := self sensor) notNil ifTrue:[
            "/ make certain all X events have been received
            device sync.
            "/ now all events have been received.
            "/ now, flush all pointer events
            sensor flushKeyboardFor:nil
        ].
        device ungrabKeyboard.
    ].

    "Modified: / 2.11.1998 / 11:47:44 / ps"
    "Created: / 5.12.1998 / 14:20:46 / ps"
! !

!ExtendedComboBox::Popup methodsFor:'initialization'!

destroy
"ungrab resources (mouse and keyboard)

return <self>" 

    self ungrabMouseAndKeyboard.
    super destroy

    "Modified: / 2.11.1998 / 10:29:03 / ps"
    "Created: / 5.12.1998 / 14:21:42 / ps"
!

initialize
"setup default values. this class is a wrapper for the popup view
to handle the event grabbing

return <self>"

    super initialize.
    hasFocus := false.
    pointerInScrollbar := false.

    "Modified: / 27.11.1998 / 15:02:16 / ps"
    "Created: / 5.12.1998 / 14:21:48 / ps"
!

mapped
"grab resources (mouse and keyboard)

return <self>" 

    super mapped.
    self grabMouseAndKeyboard.

    "Created: / 5.12.1998 / 14:21:55 / ps"
    "Modified: / 5.12.1998 / 14:29:28 / ps"
!

unmap
"ungrab resources (mouse and keyboard)

return <self>" 

    self ungrabMouseAndKeyboard.
    super unmap.

    "Created: / 5.12.1998 / 14:22:01 / ps"
    "Modified: / 5.12.1998 / 14:29:24 / ps"
! !

!ExtendedComboBox::Popup methodsFor:'queries'!

isPopUpView
"return true, since I want to come up without decoration 
and popUp to top immediately.

return <self>"

    ^ true

    "Created: / 5.12.1998 / 14:57:52 / ps"
! !

!ExtendedComboBox::Popup methodsFor:'searching'!

detectViewAtX:x y:y
"start recursive search for the view at the coordinate (x@y). If it is my own view return nil
if not return the other view.

return <nil | view>"

    |v|

    ((x between:0 and:width) and:[y between:0 and:height]) ifTrue:[
        v := self detectViewAtX:x y:y in:self.
        v ~~ self ifTrue:[^ v].
    ].
    ^ nil

    "Modified: / 2.11.1998 / 16:42:33 / ps"
    "Created: / 5.12.1998 / 14:22:37 / ps"
!

detectViewAtX:x y:y in:aTopView
"recursive search for the view at the coordinate (x@y) in a TopView.

return <view>"

    |subviews|

    subviews := aTopView subViews.

    subviews isNil ifTrue:[
        ^ aTopView
    ].
    subviews do:[:v||p|
        ((x between:(v left) and:(v right)) and:[y between:(v top) and:(v bottom)]) ifTrue:[
            p := device translatePoint:(x@y) from:(aTopView id) to:(v id).
            ^ self detectViewAtX:p x y:p y in:v.
        ]
    ].
    ^ aTopView

    "Modified: / 2.11.1998 / 15:20:26 / ps"
    "Created: / 5.12.1998 / 14:22:42 / ps"
! !

!ExtendedComboBox::Popup methodsFor:'startUp'!

extent:maxExtent popupView:aView
"set the extent of the popup view and add it to self (the wrapper for the popup view
to handle the event grabbing

return <self>"

    aView extent:(maxExtent - (4@4)).
    self add:aView.
    self origin:2@2 corner:(maxExtent - (2@2)).

    "Created: / 5.12.1998 / 14:47:36 / ps"
    "Modified: / 5.12.1998 / 14:59:36 / ps"
! !

!ExtendedComboBox class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libwidg2/ExtendedComboBox.st,v 1.1 1998-12-08 11:11:58 ps Exp $'
! !
